﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace FFTapp
{
    public partial class Form1 : Form
    {
        private void getData()
        {
            //send "s" for starting/restartomg FFT
            byte[] dat = Encoding.GetEncoding("SHIFT-JIS").GetBytes("s");
            serialPort1.Write(dat, 0, dat.Length);
        }

        public Form1()
        {
            string ComNumber;

            InitializeComponent();

            chart1.Series.Clear();
            chart1.Series.Add("FFT");

            chart1.Series["FFT"].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;

            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = 4;
            chart1.ChartAreas[0].AxisX.Interval = 1;
            chart1.ChartAreas[0].AxisX.Title = "Frequency ( kHz )";
            chart1.ChartAreas[0].AxisY.Minimum = 0;
            chart1.ChartAreas[0].AxisY.Maximum = 5;
            chart1.ChartAreas[0].AxisY.Interval = 1;
            chart1.ChartAreas[0].AxisY.Title = "Power";


            CDCcom comport = new CDCcom("VID_04D8&PID_000A");
            ComNumber = comport.getComNumber();

            if (ComNumber == null)
            {
                MessageBox.Show("CDC COM Port is not found!");
                Environment.Exit(0);
            }

            serialPort1.BaudRate = 57600;
            serialPort1.PortName = ComNumber;
            serialPort1.ReceivedBytesThreshold = 128;
            serialPort1.Open();
            getData();//start
        }

        private delegate void Delegate_RcvDataToChart(string data);

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            string a = serialPort1.ReadExisting();
            BeginInvoke(new Delegate_RcvDataToChart(RcvDataToChart), new Object[] { a });
        }

        private void RcvDataToChart(string data)
        {
            int i;
            string a;
            double[] x = new double[32];

            int k = data.Length;

            for (i = 0; i < 32; i++)
            {
                a = data.Substring(4 * i, 4);
                x[i] = (double)Convert.ToInt32(a, 16);
            }

            chart1.Series["FFT"].Points.Clear();

            for (i = 0; i < 32; i++)
            {
                chart1.Series["FFT"].Points.AddXY((double)i * 4 / 32, x[i]);
            }

            getData();//restart
        }

        private void chart1_Click(object sender, EventArgs e)
        {

        }
    }
}
